/*
						+--------------------------------+
                        |                                |
                        |     *** TX2 Compiller ***      |
                        |                                |
                        |          L.Polok 2002         |
                        |                                |
                        |             Main.c             |
                        |                                |
						+--------------------------------+
*/

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "Function.h"

#define PRINT_NFO
#undef  PRINT_NFO

CFunction::~CFunction()
{
	if(var_value != NULL)
		free((void*)var_value);
	// free memory
	var_num = 0;
}

int CFunction::Create(int lenght, int *value)
{
	if(var_num == 0)
		var_value = (int*) malloc(lenght * sizeof(int));
	else
		var_value = (int*) realloc(var_value, lenght * sizeof(int));
	if(var_value == NULL) {
		var_num = 0;
		// not enough memory
		return 0;
	}
	var_num = (int)(1e-10 + log(lenght) / log(2));
	memcpy(var_value, value, lenght * sizeof(int));
	// copy function data

	return CreateEquation();
}

void CFunction::Print()
{
	//printf("%s\n%s\n", f_eq.eq_neg, f_eq.eq_str);
	printf("%d + 3 bytes\n", chunk_len);
}

char *CFunction::UnitToChunk(QM_Unit *u)
{
	char *tmp;
	int u_l;
	int i, a;

	u_l = (int)ceil((float)(var_num * 2) / 8);
	// vars + negs

	if((tmp = (char*) malloc(u_l)) == NULL)
		return NULL;
	// lock memory

	memset(tmp, 0, u_l);
	// set memory to nulls

	a = 0;
	for(i = 0; i < u->bit_cnt; i ++) {
		if(u->bit[i] == 1) {
			tmp[a >> 3] |= (1 << (a & 7));
		} else if(u->bit[i] == 0) {
			tmp[(a + var_num) >> 3] |= (1 << ((a + var_num) & 7));
		}
		a ++;
	}
	// construct chunk

	return tmp;
}

int CFunction::PowerOfTwo(int n)
{
	int i, r;

	r = 1;
	for(i = 0; i < n; i ++)
		r *= 2;
	// powero of two

	return r;
}

int CFunction::InitTree(QM_Tree *tree)
{
	int i;

	if((tree->unit = (QM_Unit*) malloc(tree->unit_num * sizeof(QM_Unit))) == NULL) {
		printf("Malo pameti pro kraceni funkce !");
		return 0;
	} // tree alloc

	for(i = 0; i < tree->unit_num; i ++)
		tree->unit[i].used = 0;
	// mark all the units as unused

	return 1;
}

int CFunction::CreateUnit(QM_Unit *unit, int value, int bit_cnt)
{
	int i;

	if((unit->bit = (int*) malloc(bit_cnt * sizeof(int))) == NULL)
		return 0;
	// alloc

	unit->bit_cnt = bit_cnt;
	unit->one_cnt = 0;
	unit->val = value;
	for(i = 0; i < bit_cnt; i ++) {
		unit->bit[i] = value & 1;
		unit->one_cnt += value & 1;
		value >>= 1;
	}// create

	return 1;
}

int CFunction::Count_Differs(QM_Unit *a, QM_Unit *b)
{
	int i, r;

	r = 0;
	for(i = 0; i < a->bit_cnt; i ++)
		if(a->bit[i] != b->bit[i])
			r ++;
	// counting different bits

	return r;

	/*int r;
	int x_v;

	x_v = a->val ^ b->val; // xor
	r = 0;
	while(x_v) {
		r += x_v & 1;
		x_v >>= 1;
	}

	if(r != r1) {
		return r1;
	}

	return r;*/

	/*int i, r;

	r = 0;
	for(i = 0; i < a->bit_cnt; i ++)
		r += a->bit[i] ^ b->bit[i];
	// counting different bits

	return r;*/
}

int CFunction::SimilarUnits(QM_Tree *tree)
{
	int i, j, r;

	r = 0;
	for(i = 0; i < tree->unit_num; i ++) {
		for(j = i + 1; j < tree->unit_num; j ++) {
			if(abs(tree->unit[i].one_cnt - tree->unit[j].one_cnt) != 1)
				continue;
			if(Count_Differs(&tree->unit[i], &tree->unit[j]) == 1)
				r ++;
		}
	} // counting diferencies

	return r;
}

void CFunction::CombineUnit(QM_Unit *a, QM_Unit *b, QM_Unit *r)
{
	int i, j;

	CreateUnit(r, 0, a->bit_cnt);
	// alloc r

	r->val = 0;
	r->one_cnt = 0;
	for(i = 0; i < a->bit_cnt; i ++) {
		if(a->bit[i] == b->bit[i]) {
			r->bit[i] = a->bit[i];
			r->val += 1 << i;
			r->one_cnt += a->bit[i];
		} else {
			r->bit[i] = 2;
			r->one_cnt ++;
		}
		// combining swine ...
	}

	r->parent_num = a->parent_num + b->parent_num;
	if((r->parent = (int*) malloc(
	   r->parent_num * sizeof(int))) == NULL) {
		printf("Nedostatek pameti [1] !\n");
		return;
	}
	for(j = 0, i = 0; i < a->parent_num; i ++, j ++)
        r->parent[j] = a->parent[i];
	for(i = 0; i < b->parent_num; i ++, j ++)
        r->parent[j] = b->parent[i];
	// parents
}

char *CFunction::UnitToStr(QM_Unit *u)
{
	char *tmp;
	int i, l, a;

	l = 1;
	for(i = 0; i < u->bit_cnt; i ++) {
		if(u->bit[i] != 2)
			l ++;
	} // count len

	if((tmp = (char*) malloc(l)) == NULL)
		return NULL;
	tmp[l - 1] = 0;

	a = 0;
	for(i = 0; i < u->bit_cnt; i ++) {
		if(u->bit[i] == 1) {
			tmp[a] = 'A' + i;
			a ++;
		} else if(u->bit[i] == 0) {
			tmp[a] = 'a' + i;
			a ++;
		}
	} // construct chars

	return tmp;
}

char *CFunction::UnitToNeg(QM_Unit *u)
{
	char *tmp;
	int i, l, a;

	l = 1;
	for(i = 0; i < u->bit_cnt; i ++) {
		if(u->bit[i] != 2)
			l ++;
	} // count len

	if((tmp = (char*) malloc(l)) == NULL)
		return NULL;
	tmp[l - 1] = 0;

	a = 0;
	for(i = 0; i < u->bit_cnt; i ++) {
		if(u->bit[i] == 1) {
			tmp[a] = ' ';
			a ++;
		} else if(u->bit[i] == 0) {
			tmp[a] = '_';
			a ++;
		}
	} // construct chars

	return tmp;
}

void CFunction::AddTreeToMatrix(QM_Matrix *m, QM_Tree *tree)
{
	int i, j, r, t;

	if(tree->node != NULL)
		AddTreeToMatrix(m, tree->node);
	// traverse node

	for(i = 0; i < tree->unit_num; i ++) {
		if(tree->unit[i].used == 0) {
			r = 0;
			for(j = 0; j < tree->unit[i].parent_num; j ++) {
				if(var_value[tree->unit[i].parent[j]] == 2)
					r ++;
			}
			if(r == tree->unit[i].parent_num)
				continue;
			// unit's parents are log.X
			
			r = 0;
			t = 0;
			for(j = 0; j < tree->unit[i].parent_num; j ++) {
				if(m->bit_used[tree->unit[i].parent[j]] != 1)
					r ++;
			}
			// count bits that is covered by unit
 			if(!r)
				continue;
			// bit is covered elsewhere

			for(j = 0; j < tree->unit[i].parent_num; j ++)
				m->bit_used[tree->unit[i].parent[j]] |= 1;
			// set bits to covered
			memcpy(&m->unit[m->unit_cnt ++], &tree->unit[i], sizeof(QM_Unit));
			//copy to matrix
		}
		// adding necessary units to matrix
	}
}

void CFunction::CreateQM_Tree(QM_Tree *tree)
{
	int i, j, s;

#ifdef PRINT_NFO
		printf("\rCFunction::Sim() Level %5d / %3d",
			++ crt_level, tree->unit_num);
#endif

	if((s = SimilarUnits(tree)) == 0) {
		tree->node = NULL;
		return;
	}
	// if no similar units to perform, exit

#ifdef PRINT_NFO
		printf("\rCFunction::Alc() Level %5d / %3d     ",
			crt_level, 0);
#endif

	if((tree->node = (QM_Tree*) malloc(sizeof(QM_Tree))) == NULL)
		return;
	tree->node->node = NULL;
	// alloc

#ifdef PRINT_NFO
		printf("\rCFunction::Prp() Level %5d / %3d",
			crt_level, 0);
#endif

	if((tree->node->unit = (QM_Unit*) malloc(s * sizeof(QM_Unit))) == NULL)
		return;
	tree->node->unit_num = 0;
	for(i = 0; i < s; i ++)
		tree->node->unit[i].used = 0;
	// prepare units in node

#ifdef PRINT_NFO
	printf("\rCFunction::Crt() Level %5d / %3d     ",
		crt_level, s);
#endif

	for(i = 0; i < tree->unit_num; i ++) {
		for(j = i + 1; j < tree->unit_num; j ++) {
			if(abs(tree->unit[i].one_cnt - tree->unit[j].one_cnt) != 1)
				continue;
			if(Count_Differs(&tree->unit[i], &tree->unit[j]) == 1) {
				CombineUnit(&tree->unit[i], &tree->unit[j],
				   &tree->node->unit[tree->node->unit_num]);
				// computes unit
				if(Find_Unit(&tree->node->unit
				   [tree->node->unit_num], tree->node) != -1) {
					tree->node->unit_num ++;
					tree->unit[i].used = 1;
					tree->unit[j].used = 1;
				} else {
					Free_Unit(&tree->node->unit
						[tree->node->unit_num]);
				}
				// if not found, add it !
			}
			// similar unit found
		}
#ifdef PRINT_NFO
		printf("\rCFunction::Crt() Level %5d / %3d",
			crt_level, (i * 100) / tree->unit_num);
#endif
	}

	for(i = 0; i < tree->unit_num; i ++) {
		if(tree->unit[i].used)
			Free_Unit(&tree->unit[i]);
	}
	// freeing up unused memory

	CreateQM_Tree(tree->node);
	// next level ..

	#ifdef PRINT_NFO
		printf("\rCFunction::Bck() Level %5d              ", -- crt_level);
	#endif
}

int CFunction::CreateEquation()
{
	char *tmp_unit;
	QM_Tree tree;
	QM_Matrix m;
	char *str;
	int r_bit;
	int i, j;
	int bit;

	crt_level = 0;
#ifdef PRINT_NFO
	printf("CFunction::Crt() Level %5d", crt_level);
#endif

	tree.unit_num = 0;
	for(i = 0; i < PowerOfTwo(var_num); i ++) {
		if(var_value[i])
			tree.unit_num ++;
	} // ve stromu muzou byt vsechny kombinace,
	  // ktere maji ve vysledku jednicku

	if(tree.unit_num == 0) {
		/*f_eq.eq_len = 1;
		if((f_eq.eq_str = (char*) malloc(2 * sizeof(char))) == NULL) {
			printf("ERROR : Fatal error !\n");
			return 0;
		}
		if((f_eq.eq_neg = (char*) malloc(2 * sizeof(char))) == NULL) {
			printf("ERROR : Fatal error !\n");
			return 0;
		}
		f_eq.eq_str[1] = 0;
		f_eq.eq_neg[1] = 0;
		f_eq.eq_str[0] = '0';
		f_eq.eq_neg[0] = ' ';*/

		chunk_len = 0;
		// vars + negs
		if((chunk = (char*) malloc(chunk_len + 3)) == NULL)
			return 0;
		chunk[0] = 0;
		chunk[1] = 0;
		chunk[2] = 0;

		return 1;
	}
	// pokud jsou vsechny 0

	if(tree.unit_num == PowerOfTwo(var_num)) {
		/*f_eq.eq_len = 1;
		if((f_eq.eq_str = (char*) malloc(2 * sizeof(char))) == NULL) {
			printf("ERROR : Fatal error !");
			return NULL;
		}
		if((f_eq.eq_neg = (char*) malloc(2 * sizeof(char))) == NULL) {
			printf("ERROR : Fatal error !");
			return NULL;
		}
		f_eq.eq_str[1] = 0;
		f_eq.eq_neg[1] = 0;
		f_eq.eq_str[0] = '1';
		f_eq.eq_neg[0] = ' ';*/

		chunk_len = 0;
		// vars + negs
		if((chunk = (char*) malloc(chunk_len + 3)) == NULL)
			return 0;
		chunk[0] = (char)0x80; // first byte in word
		chunk[1] = 0;
		chunk[2] = 0;

		return 1;
	}
	// pokud jsou vsechny 1

	if(!InitTree(&tree))
		return 0;
	// inits the tree, allocs the units and marks it as unused

	j = 0;
	for(i = 0; i < PowerOfTwo(var_num); i ++) {
		if(!var_value[i])
			continue;
		if(!CreateUnit(&tree.unit[j], i, var_num)) {
			printf(" ERROR : Unepected error !\n");
			return 0;
		}
		tree.unit[j].parent_num = 1;
		if((tree.unit[j].parent = (int*) malloc(sizeof(int))) == NULL) {
			printf(" ERROR : Not enough memory !\n");
			return 0;
		}
		tree.unit[j].parent[0] = i;
		//
		if(var_value[i] == 2)
			tree.unit[j].used = 1; // x - value
		j ++;
	} // fills units with i

	CreateQM_Tree(&tree);
	// creating tree ...

	if((m.bit_used = (int*) malloc(PowerOfTwo(var_num) * sizeof(int))) == NULL) {
		printf(" ERROR : Not enough memory !\n");
		return 0;
	}
	for(i = 0; i < PowerOfTwo(var_num); i ++)
		m.bit_used[i] = 0;
	m.bit_cnt = PowerOfTwo(var_num);
	// set bits to unused

	if((m.unit = (QM_Unit*) malloc(PowerOfTwo(var_num) * sizeof(QM_Unit))) == NULL) {
		printf(" ERROR : Not enough memory !\n");
		return 0;
	}
	m.unit_cnt = 0;
	// set & alloc units

	AddTreeToMatrix(&m, &tree);
	// add unused units to matrix

	f_eq.eq_len = 0;// Disable equation generation
	for(i = 0; i < m.unit_cnt; i ++) {
		str = UnitToStr(&m.unit[i]);
		f_eq.eq_len += strlen(str) + 3;
		free((void*)str);
	} // count len

	if((f_eq.eq_str = (char*) malloc(f_eq.eq_len + 1)) == NULL) {
		printf(" ERROR : Not enough memory !\n");
		return 0;
	}
	if((f_eq.eq_neg = (char*) malloc(f_eq.eq_len + 1)) == NULL) {
		printf(" ERROR : Not enough memory !\n");
		return 0;
	} // alloc

	f_eq.eq_str[0] = 0;
	for(i = 0; i < m.unit_cnt; i ++) {
		str = UnitToStr(&m.unit[i]);
		strcat(f_eq.eq_str, str);
		if(i + 1 < m.unit_cnt)
			strcat(f_eq.eq_str, " + ");
		free((void*)str);
	}
	f_eq.eq_neg[0] = 0;
	for(i = 0; i < m.unit_cnt; i ++) {
		str = UnitToNeg(&m.unit[i]);
		strcat(f_eq.eq_neg, str);
		if(i + 1 < m.unit_cnt)
			strcat(f_eq.eq_neg, "   ");
		free((void*)str);
	}
	// and translate to text

	chunk_len = (int)ceil((float)(var_num * 2 * m.unit_cnt) / 8);
	// vars + negs
	if((chunk = (char*) malloc(chunk_len + 3)) == NULL)
		return 0;
	memset(chunk, 0, chunk_len + 3);
	chunk[0] = (chunk_len >> 8);
	chunk[1] = (chunk_len & 0xff);
	chunk[2] = var_num;
	// lock memory
	for(i = 0; i < m.unit_cnt; i ++) {
		tmp_unit = UnitToChunk(&m.unit[i]);
		for(j = 0; j < (var_num * 2); j ++) {
			bit =  ((var_num << 1) - 1 - j);
			r_bit = (tmp_unit[bit >> 3] >> (bit & 7)) & 1;
			bit =  i * (var_num << 1) + j;
			chunk[3 + (bit >> 3)] |=
				(r_bit << (bit & 7));
		}
		free((void*)tmp_unit);
	}
	// write units to chunk

	Free_Matrix(&m);
	if(tree.node != NULL)
		Free_Tree(tree.node);
	// freeing up ! :-)

	#ifdef PRINT_NFO
		printf("\rCFunction::Crt() Level %5d\n", crt_level);
	#endif

	return 1;
}

void CFunction::Free_Matrix(QM_Matrix *m)
{
	free((void*)m->bit_used);
	free((void*)m->unit);
}

void CFunction::Free_Unit(QM_Unit *u)
{
	free((void*)u->parent);
	free((void*)u->bit);
}

void CFunction::Free_Tree(QM_Tree *t)
{
	int i;

	if(t->node != NULL)
		Free_Tree(t->node);
	// traverse node

	for(i = 0; i < t->unit_num; i ++) {
		if(t->unit[i].used)
			continue;
		free((void*)t->unit[i].parent);
		free((void*)t->unit[i].bit);
	}
	free((void*)t->unit);

	free((void*)t);

	t = NULL;
}

void CFunction::Free_Equation(EQUATION *e)
{
	free((void*)e->eq_str);
	free((void*)e->eq_neg);
	free((void*)e);

	e = NULL;
}

int CFunction::Find_Unit(QM_Unit *unit, QM_Tree *tree)
{
	int i, j;

	for(i = 0; i < tree->unit_num; i ++) {
        if(unit->bit_cnt == tree->unit[i].bit_cnt) {
			for(j = 0; j < unit->bit_cnt; i ++) {
				if(unit->bit[j] != tree->unit[i].bit[j])
					continue;
			}
			return i;
		}
	}
	// searching for unit

	return -1;
}
