/*
						+--------------------------------+
                        |                                |
                        |     *** TX2 Compiller ***      |
                        |                                |
                        |          L.Polok 2002         |
                        |                                |
                        |             Main.c             |
                        |                                |
						+--------------------------------+
*/

typedef struct {
	char *eq_str;
	char *eq_neg;
	int   eq_len;
} EQUATION;

typedef struct {
	int *parent;
	int parent_num;
	int *bit;
	int bit_cnt;
	int one_cnt;
	int val;
	int used;
} QM_Unit;

typedef struct QMTree {
	struct QMTree *node;
	QM_Unit *unit;
	int unit_num;
} QM_Tree;

typedef struct {
	QM_Unit *unit;
	int unit_cnt;
	int *bit_used;
	int bit_cnt;
} QM_Matrix;

class CFunction  
{
public:
	//
	CFunction() { var_num = 0; var_value = NULL; }
	CFunction(int lenght, int *value) { var_num = 0; this->Create(lenght, value); }
	virtual ~CFunction();
	//
	int Create(int lenght, int *value);
	//
	void Print();
	int Chunk_Len() { return chunk_len + 3; }
	char *Chunk() { return chunk; }
	//
private:
	int Find_Unit(QM_Unit *unit, QM_Tree *tree);
	int crt_level;
	// variables
	//
	int var_num;
	int *var_value;
	//
	EQUATION f_eq;
	//
	char *chunk;
	int chunk_len;
	//

	// functions
	//
	int PowerOfTwo(int n);
	//
	int InitTree(QM_Tree *tree);
	void CreateQM_Tree(QM_Tree *tree);
	//
	void AddTreeToMatrix(QM_Matrix *m, QM_Tree *tree);
	//
	int CreateUnit(QM_Unit *unit, int value, int bit_cnt);
	void CombineUnit(QM_Unit *a, QM_Unit *b, QM_Unit *r);
	char *UnitToStr(QM_Unit *u);
	char *UnitToNeg(QM_Unit *u);
	char *UnitToChunk(QM_Unit *u);
	int Count_Differs(QM_Unit *a, QM_Unit *b);
	int SimilarUnits(QM_Tree *tree);
	//
	int CreateEquation();
	//
	void Free_Matrix(QM_Matrix *m);
	void Free_Unit(QM_Unit *u);
	void Free_Tree(QM_Tree *t);
	void Free_Equation(EQUATION *e);
	//
};
